{{
This module defines an "interrupt device".

Three registers are used:

 * status is interrupt status register  ISR
 * mask is interrupt mask register      IMR
 * pins is interrupt pin assignment reg IPAR

Usage:
 1 set IMR
 2 set IPAR 
 3 start device
 4 poll ISR

Potentially, the LMM should have interrupt device register
accessor methods (with locks?) to manage the device.
}}


{
'--------------------------------------------------------------
' <save> for testing.
'--------------------------------------------------------------

CON
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000

OBJ
  disp: "VGA_Text"
  'disp: "TV_Text"

CON
  base = 16
  'base = 12
    
VAR
  long  status
  long  mask
  long  pins

PUB main | mymask

  disp.start(base)
  
  status := 0
  mymask := $ff000fff
  mask   := mymask
  pins   := mymask

  start(@status)

  repeat
    if status
      disp.str(string($d,"ISR "))
      disp.hex(status, 8)
      status := 0


'--------------------------------------------------------------
' </save>
'--------------------------------------------------------------
}

VAR
  long cog
  
PUB start(regptr)
  cog := cognew(@pinMonEntry, regptr) + 1

PUB stop
  if cog
    cogstop(cog~ -1)
    
DAT
pinMonEntry   org       0

              mov       statptr, par    
              mov       maskptr, par
              add       maskptr, #4
              mov       pinsptr, par
              add       pinsptr, #8
              
pinMonLoop    rdlong    IPAR, pinsptr           ' 88ns
              andn      dira, IPAR              ' 50ns
              mov       IPAR, ina               ' 50ns
              rdlong    IMR,  maskptr           ' 88ns
              and       IPAR, IMR wz            ' 50ns
        if_nz wrlong    IPAR, statptr           ' 88ns
              jmp       #pinMonLoop             ' 50ns


IMR           res 1
IPAR          res 1

maskptr       res 1
pinsptr       res 1
statptr       res 1

              fit       48